﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using AIOUSBNet;

namespace Sample1
{
    public partial class FormDetect : Form
    {
        private bool[] DeviceOK = new bool[8];

        // For the ovreloaded contructor as a sub form:
        Form1 mainForm;

        public FormDetect()
        {
            InitializeComponent();
            
            listBoxDeviceList.Items.Clear();
        }

        public FormDetect(Form1 mainForm)
        {
            // Ovreloaded contructor as a parent aware sub form:

            // set access to mainform
            this.mainForm = mainForm;

            InitializeComponent();

            btnDetect_Click(this, null);
        }

        private void btnDetect_Click(object sender, EventArgs e)
        {
            UInt32 DeviceMask = AIOUSB.GetDevices();
            bool Found = false;

            listBoxDeviceList.Items.Clear();
            
            for (int i = 0; i <= 7; i++)
	        {
                DeviceOK[i] = false;

                if ((DeviceMask & (1 << i)) != 0)
                {
                    uint locDeviceIndex = (uint)i;

                    string strName;
                    // Detect all USB-IIRO-16 Boards: 
                    // Get device info:
                    uint Status = AIOUSB.QueryDeviceInformation(locDeviceIndex, out UInt32 uPID, out _, out strName, out _, out _);

                    switch (uPID)
                    {
                    case 0x8020:
                        listBoxDeviceList.Items.Add(" " + strName); //CTR15
                        DeviceOK[i] = true;
                        Found = true;
                        break;
                    default:
                        listBoxDeviceList.Items.Add(" Not for this sample.");                        
                        break;
                    }
                }
                else
                {
                    listBoxDeviceList.Items.Add(" No device at this index.");
                }
            }
            
            if (Found)
            {
                txtStatus.Text = " Select device and click Accept or Cancel.";
            }
            else
            {
                txtStatus.Text = " No compatible devices found!";
            }	        
        }

        private void btnAccept_Click(object sender, EventArgs e)
        {
            // Pass new index to mainform
            UInt32 myuint = 0;
            int myint = 0;
            myint = listBoxDeviceList.SelectedIndex;
             
            myuint = (uint)myint;
            mainForm.DeviceIndex = myuint;

            // Clear the controls:
            listBoxDeviceList.Items.Clear();
            txtStatus.Clear();

            // Close this form:
            this.Close();
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            // Reject changes:
            // Device Index defaults to First available:

            txtStatus.Text = "No change to device selection.";
            
            // Call Sleep to allow user to read message: 
            // System.Threading.Thread.Sleep(2000);

            // Clear the controls:
            listBoxDeviceList.Items.Clear();
            txtStatus.Clear();

            this.Close();
        }

        private void FormDetect_Load(object sender, EventArgs e)
        {

        }
    }
}
